/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	D3DBase.cpp													 */
/* eF		Direct3DNX t@C								 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/03/07													 */
/* ========================================================================= */

#include "StdAfx.h"
#include <stdio.h>
#include "D3DBase.h"


/* ========================================================================= */
/* ֐F	CD3DBase::CD3DBase												 */
/* eF	RXgN^													 */
/* tF	2006/03/07														 */
/* ========================================================================= */

CD3DBase::CD3DBase()
{
	m_bWindow		= TRUE;
	m_hWnd			= NULL;
	m_pD3D			= NULL;
	m_pD3DDevice	= NULL;
	m_sizeWindow.cx	= 0;
	m_sizeWindow.cy	= 0;
	ZeroMemory (&m_stD3Dpp, sizeof (m_stD3Dpp));
}


/* ========================================================================= */
/* ֐F	CD3DBase::~CD3DBase												 */
/* eF	fXgN^													 */
/* tF	2006/03/07														 */
/* ========================================================================= */

CD3DBase::~CD3DBase()
{
	Cleanup ();
}


/* ========================================================================= */
/* ֐F	CD3DBase::Run													 */
/* eF	s															 */
/* tF	2006/03/07														 */
/* ========================================================================= */

HRESULT CD3DBase::Run(
	HINSTANCE hInst,		/* [in] CX^Xnh */
	LPCSTR pszCaption,		/* [in] LvV */
	int nWidth,				/* [in] EBhE̕ */
	int nHeight,			/* [in] EBhE̍ */
	BOOL bWindow)			/* [in] TRUE:EBhE FALSE:tXN[ */
{
	HWND hWndParent;
	HRESULT hr, hRet;
	DWORD dwStyle;
	WNDCLASS wc;
	RECT rcTmp;

	hRet = E_FAIL;

	m_sizeWindow.cx = nWidth;
	m_sizeWindow.cy = nHeight;

	wc.hInstance		= hInst;
	wc.lpszClassName	= CLNAME;
	wc.lpfnWndProc		= (WNDPROC)WndProcEntry;
	wc.style			= 0;
	wc.hIcon			= NULL;
	wc.hCursor			= LoadCursor ((HINSTANCE)NULL, IDC_ARROW);
	wc.lpszMenuName		= NULL;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hbrBackground	= (HBRUSH)GetStockObject (BLACK_BRUSH);

	/* EBhẼNXo^ */
	if (!RegisterClass (&wc)) {
		goto Exit;
	}

	hWndParent	= GetDesktopWindow ();
//	dwStyle		= WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_CLIPCHILDREN | WS_MINIMIZEBOX;
	dwStyle		= WS_OVERLAPPEDWINDOW;
	if (bWindow == FALSE) {
		hWndParent	= HWND_DESKTOP;
		dwStyle		= WS_VISIBLE;
	}

	/* EBhETCYvZ */
	SetRect (&rcTmp, 0, 0, nWidth, nHeight);
	AdjustWindowRect (&rcTmp, dwStyle, FALSE);

	m_hWnd = CreateWindow (
				CLNAME,
				pszCaption,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT,
				rcTmp.right - rcTmp.left, rcTmp.bottom - rcTmp.top,
				hWndParent,
				NULL,
				hInst,
				this);
	if (m_hWnd == NULL) {
		goto Exit;
	}

	hr = Init (m_hWnd, bWindow);
	if (FAILED (hr)) {
		goto Exit;
	}

	ShowWindow (m_hWnd, SW_SHOWDEFAULT);
	UpdateWindow (m_hWnd);

	Loop ();

	hRet = hr;
Exit:
	UnregisterClass (CLNAME, wc.hInstance);
	return hRet;
}


/* ========================================================================= */
/* ֐F	CD3DBase::Render												 */
/* eF	`															 */
/* tF	2006/03/07														 */
/* ========================================================================= */

BOOL CD3DBase::Render(void)
{
	BOOL bRet;
	HRESULT hr;

	bRet = FALSE;

	hr = m_pD3DDevice->Clear (0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB (0, 0, 255), 1.0f, 0);
	if (FAILED (hr)) {
		goto Exit;
	}

	/* V[Jn */
	hr = m_pD3DDevice->BeginScene ();
	if (FAILED (hr)) {
		goto Exit;
	}

	/* V[̕` */
	RenderScene ();

	/* V[I */
	hr = m_pD3DDevice->EndScene ();

	/* obNobt@vC}obt@֓] */
	hr = m_pD3DDevice->Present (NULL, NULL, NULL, NULL);
	if (FAILED (hr)) {
		m_pD3DDevice->Reset (&m_stD3Dpp);
		goto Exit;
	}

	bRet = TRUE;
Exit:
	return bRet;
}


/* ========================================================================= */
/* ֐F	CD3DBase::Cleanup												 */
/* eF	j															 */
/* tF	2006/03/07														 */
/* ========================================================================= */

void CD3DBase::Cleanup(void)
{
	SAFE_RELEASE (m_pD3DDevice);
	SAFE_RELEASE (m_pD3D);
}


/* ========================================================================= */
/* ֐F	CD3DBase::Init													 */
/* eF																 */
/* tF	2006/03/07														 */
/* ========================================================================= */

HRESULT CD3DBase::Init(HWND hWnd, BOOL bWindow)
{
	HRESULT hr, hRet;
	D3DPRESENT_PARAMETERS stD3Dpp;
	D3DDISPLAYMODE stDispMode;

	hRet = E_FAIL;

	/* C^[tFCX̎擾 */
	m_pD3D = Direct3DCreate9 (D3D_SDK_VERSION);
	if (m_pD3D == NULL) {
		goto Exit;
	}
	m_bWindow = bWindow;

	m_pD3D->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &stDispMode);

	/* ݒ */
	ZeroMemory (&stD3Dpp, sizeof (stD3Dpp));
	stD3Dpp.Windowed = bWindow;
	if (bWindow) {
		stD3Dpp.BackBufferFormat = stDispMode.Format;

	} else {
		stD3Dpp.BackBufferFormat = D3DFMT_R5G6B5;
	}
	stD3Dpp.BackBufferWidth		= m_sizeWindow.cx;
	stD3Dpp.BackBufferHeight	= m_sizeWindow.cy;
	stD3Dpp.SwapEffect				= D3DSWAPEFFECT_DISCARD;
	stD3Dpp.EnableAutoDepthStencil	= 1;
	stD3Dpp.AutoDepthStencilFormat	= D3DFMT_D16;

	m_stD3Dpp = stD3Dpp;

	/* foCX̍쐬 */
	hr = m_pD3D->CreateDevice (
			0,
			D3DDEVTYPE_HAL,							/* n[hEFA */
			hWnd,
			D3DCREATE_HARDWARE_VERTEXPROCESSING,	/* n[hEFAɂ钸_ */
			&stD3Dpp,
			&m_pD3DDevice);

	if (FAILED (hr)) {
		hr = m_pD3D->CreateDevice (
				0,
				D3DDEVTYPE_HAL,							/* n[hEFA */
				hWnd,
				D3DCREATE_SOFTWARE_VERTEXPROCESSING,	/* \tgEFAɂ钸_ */
				&stD3Dpp,
				&m_pD3DDevice);

		if (FAILED (hr)) {
			hr = m_pD3D->CreateDevice (
					0,
					D3DDEVTYPE_REF,							/* \tgEFA */
					hWnd,
					D3DCREATE_HARDWARE_VERTEXPROCESSING,	/* n[hEFAɂ钸_ */
					&stD3Dpp,
					&m_pD3DDevice);

			if (FAILED (hr)) {
				goto Exit;
			}
		}
	}

	hRet = hr;
Exit:
	return hRet;
}


/* ========================================================================= */
/* ֐F	CD3DBase::BeforeLoop											 */
/* eF	[vJnO													 */
/* tF	2006/05/29														 */
/* ========================================================================= */

void CD3DBase::BeforeLoop(void)
{
	SetRender ();
}


/* ========================================================================= */
/* ֐F	CD3DBase::Loop													 */
/* eF	C[v													 */
/* tF	2006/03/07														 */
/* ========================================================================= */

INT CD3DBase::Loop(void)
{
	INT nRet;
	MSG msg;

	nRet = 0;
	ZeroMemory (&msg, sizeof (msg));

	BeforeLoop ();

	while (1) {
		while (PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE)) {
			if (msg.message == WM_QUIT) {
				goto Exit;
			}

			GetMessage (&msg, NULL, 0, 0);
			TranslateMessage (&msg);
			DispatchMessage (&msg);
		}

		Render();
	}

	AfterLoop ();
Exit:
	nRet = msg.wParam;
	return nRet;
}


/* ========================================================================= */
/* ֐F	CD3DBase::AfterLoop												 */
/* eF	[vI													 */
/* tF	2006/05/29														 */
/* ========================================================================= */

void CD3DBase::AfterLoop(void)
{
}


/* ========================================================================= */
/* ֐F	CD3DBase::SetRender												 */
/* eF	_OXe[g̐ݒ										 */
/* tF	2006/03/10														 */
/* ========================================================================= */

HRESULT CD3DBase::SetRender(void)
{
	HRESULT hr, hRet;

	hRet = E_FAIL;

	hr = m_pD3DDevice->SetRenderState (D3DRS_ZENABLE, D3DZB_TRUE);	/* Zobt@ */
	hr = m_pD3DDevice->SetRenderState (D3DRS_AMBIENT, 0xFFFFFFFF);	/* ArGgCg */

	hRet = S_OK;
	return hRet;
}


/* ========================================================================= */
/* ֐F	CD3DBase::RenderScene											 */
/* eF	V[̕`													 */
/* tF	2006/03/10														 */
/* ========================================================================= */

void CD3DBase::RenderScene(void)
{
}


/* ========================================================================= */
/* ֐F	CD3DBase::WndProcEntry											 */
/* eF	CEBhEvV[W(Gg|Cg)					 */
/* tF	2006/03/08														 */
/* ========================================================================= */

LRESULT CALLBACK CD3DBase::WndProcEntry(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	CD3DBase* pThis;

	if (msg == WM_CREATE) {
		SetWindowLong (hWnd, GWL_USERDATA, (LONG)(((LPCREATESTRUCT)lParam)->lpCreateParams));
	}

	/* [Uf[^ this |C^擾As */
	pThis = (CD3DBase *)GetWindowLong (hWnd, GWL_USERDATA);
	if (pThis) {
		return pThis->WndProc (hWnd, msg, wParam, lParam);
	}
	return DefWindowProc (hWnd, msg, wParam, lParam);
}


/* ========================================================================= */
/* ֐F	CD3DBase::WndProc												 */
/* eF	CEBhEvV[W									 */
/* tF	2005/03/08														 */
/* ========================================================================= */

LRESULT CD3DBase::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
	HANDLE_MSG (hWnd, WM_CREATE,	OnCreate);
	HANDLE_MSG (hWnd, WM_DESTROY,	OnDestroy);
	HANDLE_MSG (hWnd, WM_SIZE,		OnSize);
	default:
		return DefWindowProc (hWnd, msg, wParam, lParam);
	}
	return 0;
}


/* ========================================================================= */
/* ֐F	CD3DBase::OnCreate												 */
/* eF	bZ[Wnh(WM_CREATE)									 */
/* tF	2006/03/08														 */
/* ========================================================================= */

BOOL CD3DBase::OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct)
{
	return TRUE;
}


/* ========================================================================= */
/* ֐F	CD3DBase::OnDestroy												 */
/* eF	bZ[Wnh(WM_DESTROY)									 */
/* tF	2006/03/08														 */
/* ========================================================================= */

void CD3DBase::OnDestroy(HWND hWnd)
{
	PostQuitMessage (0);
}


/* ========================================================================= */
/* ֐F	CD3DBase::OnSize												 */
/* eF	bZ[Wnh(WM_SIZE)										 */
/* tF	2008/02/09														 */
/* ========================================================================= */

void CD3DBase::OnSize(HWND hWnd, UINT state, int cx, int cy)
{
	m_sizeWindow.cx = cx;
	m_sizeWindow.cy = cy;

	if (cx == 0) {
		return;
	}
	Cleanup ();
	AfterLoop ();
	Init (m_hWnd, m_bWindow);
	BeforeLoop ();
}

/* Copyright(C)URARA-works 2006 */
