/* Copyright(C)URARA-works 2009 */
/* ========================================================================= */
/* t@CF	MainFrame.cpp												 */
/* eF		Ct[NX `t@C							 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2009/01/01													 */
/* ========================================================================= */

#include "StdAfx.h"
#include <stdio.h>
#include "PrimitiveRectangle.h"
#include "MainFrame.h"

/* ========================================================================= */
/* ֐F	CMainFrame::CMainFrame											 */
/* eF	RXgN^													 */
/* tF	2009/01/01														 */
/* ========================================================================= */

CMainFrame::CMainFrame()
{
	D3DXMATRIX tmp;

	m_ptPosBack.x = m_ptPosBack.y = 0;
	m_bPush = FALSE;
	m_vecAt		= D3DXVECTOR3(0.5f, 0, 0);
	m_vec3Up	= D3DXVECTOR3(0.0f, 1.0f, 0.0f);

	m_fDistance		= -2.0f;	/*  */
	m_fCameraAngle	= 0.0f;

	m_vecEye.x = 0.5f;
	m_vecEye.y = 1;
	m_vecEye.z = m_fDistance;

	m_pRect = NULL;
}


/* ========================================================================= */
/* ֐F	CMainFrame::~CMainFrame											 */
/* eF	fXgN^													 */
/* tF	2009/01/01														 */
/* ========================================================================= */

CMainFrame::~CMainFrame()
{
}


/* ========================================================================= */
/* ֐F	CMainFrame::BeforeLoop											 */
/* eF	[vJnO													 */
/* tF	2009/01/01														 */
/* ========================================================================= */

void CMainFrame::BeforeLoop(void)
{
	m_pRect = new CPrimitiveRectangle;
	m_pRect->Create (m_pD3DDevice);
	m_pRect->Set (0, 1, 1, 0);

	CD3DBase::BeforeLoop ();
}


/* ========================================================================= */
/* ֐F	CMainFrame::AfterLoop											 */
/* eF	[vI													 */
/* tF	2009/01/01														 */
/* ========================================================================= */

void CMainFrame::AfterLoop(void)
{
	SAFE_DELETE (m_pRect);
}


/* ========================================================================= */
/* ֐F	CMainFrame::RenderScene											 */
/* eF	V[̕`													 */
/* tF	2009/01/01														 */
/* ========================================================================= */

void CMainFrame::RenderScene(void)
{
	D3DXMATRIX matTmp;

	/* r[ */
	D3DXMatrixLookAtLH (
			&matTmp,
			&m_vecEye,		/* Jʒu */
			&m_vecAt,		/* _ */
			&m_vec3Up);		/*  */
	m_pD3DDevice->SetTransform (D3DTS_VIEW, &matTmp);

	/* vWFNV() */
	D3DXMatrixPerspectiveFovLH (&matTmp, D3DX_PI / 4.0f, (float)m_sizeWindow.cx / (float)m_sizeWindow.cy, 0, 10.0f);
	m_pD3DDevice->SetTransform (D3DTS_PROJECTION, &matTmp);

	m_pD3DDevice->SetRenderState (D3DRS_LIGHTING, FALSE);
	m_pD3DDevice->SetRenderState (D3DRS_CULLMODE, D3DCULL_NONE);
	m_pRect->Draw (m_pD3DDevice);
	m_pD3DDevice->SetRenderState (D3DRS_LIGHTING, TRUE);
}


/* ========================================================================= */
/* ֐F	CMainFrame::WndProc												 */
/* eF	CEBhEvV[W									 */
/* tF	2005/05/29														 */
/* ========================================================================= */

LRESULT CMainFrame::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
	HANDLE_MSG (hWnd, WM_CREATE,		OnCreate);
	HANDLE_MSG (hWnd, WM_DESTROY,		OnDestroy);
	HANDLE_MSG (hWnd, WM_RBUTTONDOWN,	OnRButtonDown);
	HANDLE_MSG (hWnd, WM_RBUTTONUP,		OnRButtonUp);
	HANDLE_MSG (hWnd, WM_LBUTTONDOWN,	OnLButtonDown);
	HANDLE_MSG (hWnd, WM_MOUSEMOVE,		OnMouseMove);
	HANDLE_MSG (hWnd, WM_MOUSEWHEEL,	OnMouseWheel);
	default:
		return CD3DBase::WndProc (hWnd, msg, wParam, lParam);
	}
	return 0;
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnCreate											 */
/* eF	bZ[Wnh(WM_CREATE)									 */
/* tF	2009/01/01														 */
/* ========================================================================= */

BOOL CMainFrame::OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct)
{
	BOOL bResult;

	bResult = CD3DBase::OnCreate (hWnd, lpCreateStruct);

	return bResult;
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnDestroy											 */
/* eF	bZ[Wnh(WM_DESTROY)									 */
/* tF	2009/01/01														 */
/* ========================================================================= */

void CMainFrame::OnDestroy(HWND hWnd)
{
	CD3DBase::OnDestroy (hWnd);
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnRButtonDown										 */
/* eF	bZ[Wnh(WM_RBUTTONDOWN)								 */
/* tF	2008/04/29														 */
/* ========================================================================= */

void CMainFrame::OnRButtonDown(HWND hWnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
	m_bPush = TRUE;
	SetCapture (hWnd);

	m_ptPosBack.x = x;
	m_ptPosBack.y = y;
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnRButtonUp											 */
/* eF	bZ[Wnh(WM_RBUTTONUP)								 */
/* tF	2008/04/29														 */
/* ========================================================================= */

void CMainFrame::OnRButtonUp(HWND hWnd, int x, int y, UINT keyFlags)
{
	m_bPush = FALSE;
	ReleaseCapture ();
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnLButtonDown										 */
/* eF	bZ[Wnh(WM_LBUTTONDOWN)								 */
/* tF	2008/02/16														 */
/* ========================================================================= */

void CMainFrame::OnLButtonDown(HWND hWnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnMouseMove											 */
/* eF	bZ[Wnh(WM_MOUSEMOVE)								 */
/* tF	2008/04/29														 */
/* ========================================================================= */

void CMainFrame::OnMouseMove(HWND hWnd, int x, int y, UINT keyFlags)
{
	float fTmp;
	D3DXMATRIX tmp;
	D3DXQUATERNION qua;

	if (m_bPush == FALSE) {
		return;
	}

	fTmp = 0;
	if (m_ptPosBack.x > x) {
		fTmp = -0.005f;
	} else {
		fTmp = 0.005f;
	}
	fTmp *= abs (m_ptPosBack.x - x);
	m_ptPosBack.x = x;
	m_fCameraAngle += fTmp;
	if (m_fCameraAngle > D3DX_PI) {
		m_fCameraAngle -= 2 * D3DX_PI;
	}
	if (m_fCameraAngle < -D3DX_PI) {
		m_fCameraAngle += 2 * D3DX_PI;
	}
	m_vecEye.x = m_fDistance * sinf (m_fCameraAngle);
	m_vecEye.z = m_fDistance * cosf (m_fCameraAngle);

	fTmp = 0;
	if (m_ptPosBack.y > y) {
		fTmp = -0.05f;
	} else {
		fTmp = 0.05f;
	}
	fTmp *= abs (m_ptPosBack.y - y);
	m_ptPosBack.y = y;
	m_vecEye.y += fTmp;
}


/* ========================================================================= */
/* ֐F	CMainFrame::OnMouseWheel										 */
/* eF	bZ[Wnh(WM_MOUSEWHEEL)								 */
/* tF	2008/04/29														 */
/* ========================================================================= */

void CMainFrame::OnMouseWheel(HWND hWnd, int xPos, int yPos, int zDelta, UINT fwKeys)
{
	if (zDelta > 0) {
		m_fDistance += 0.5f;

	} else {
		m_fDistance -= 0.5f;
	}
//	m_vecEye.x = m_fDistance * sinf (m_fCameraAngle);
//	m_vecEye.z = m_fDistance * cosf (m_fCameraAngle);
	m_vecEye.z = m_fDistance;
}


/* Copyright(C)URARA-works 2009 */
