/* Copyright(C)URARA-works 2008 */
/* ========================================================================= */
/* t@C	:PrimitiveRectangle.cpp										 */
/* e			:`p_obt@NX t@C						 */
/* 쐬			:NNt(URARA-works)							 */
/* 쐬Jn	:2008/09/21													 */
/* ========================================================================= */

#include "StdAfx.h"
#include "PrimitiveRectangle.h"

/* ========================================================================= */
/* \̒`																 */
/* ========================================================================= */

/* _obt@\ */
typedef struct {
	float	x,		/* XW */
			y,		/* YW */
			z;		/* ZW */
	D3DCOLOR color;	/* F */
} CUSTOMVERTEX, *PCUSTOMVERTEX;
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ | D3DFVF_DIFFUSE)

/* ========================================================================= */
/* ֐	:CPrimitiveRectangle::CPrimitiveRectangle						 */
/* e		:RXgN^													 */
/* t		:2008/09/21														 */
/* ========================================================================= */

CPrimitiveRectangle::CPrimitiveRectangle()
{
	m_pVB = NULL;
}


/* ========================================================================= */
/* ֐	:CPrimitiveRectangle::~CPrimitiveRectangle						 */
/* e		:fXgN^													 */
/* t		:2008/09/21														 */
/* ========================================================================= */

CPrimitiveRectangle::~CPrimitiveRectangle()
{
	SAFE_RELEASE (m_pVB);
}


/* ========================================================================= */
/* ֐	:CPrimitiveRectangle::Create									 */
/* e		:쐬															 */
/* t		:2008/09/21														 */
/* ========================================================================= */

BOOL CPrimitiveRectangle::Create(LPDIRECT3DDEVICE9 pDevice)
{
	BOOL bRet;
	HRESULT hResult;

	bRet = TRUE;

	/* _obt@쐬 */
	hResult	= pDevice->CreateVertexBuffer (
			sizeof (CUSTOMVERTEX) * 4,
			0,
			D3DFVF_CUSTOMVERTEX,
			D3DPOOL_DEFAULT,
			&m_pVB,
			NULL);
	if (FAILED (hResult)) {
		bRet = FALSE;
	}

	return bRet;
}


/* ========================================================================= */
/* ֐	:CPrimitiveRectangle::Set										 */
/* e		:Wݒ														 */
/* t		:2008/09/21														 */
/* ========================================================================= */

void CPrimitiveRectangle::Set(float left, float top, float right, float bottom, COLORREF cl/*RGB (255, 255,255)*/)
{
	int r, g, b;
	PCUSTOMVERTEX pVertex;

	if (m_pVB == NULL) {
		return;
	}

	r = GetRValue (cl);
	g = GetGValue (cl);
	b = GetBValue (cl);

	m_pVB->Lock (0, sizeof (CUSTOMVERTEX) * 4, (PVOID *)&pVertex, 0);
	/* O */
	pVertex[0].x		= left;
	pVertex[0].y		= 0;
	pVertex[0].z		= bottom;
	pVertex[0].color	= D3DCOLOR_ARGB (255, r, g, b);
	/*  */
	pVertex[1].x		= left;
	pVertex[1].y		= 0;
	pVertex[1].z		= top;
	pVertex[1].color	= D3DCOLOR_ARGB (255, r, g, b);
	/* EO */
	pVertex[2].x		= right;
	pVertex[2].y		= 0;
	pVertex[2].z		= bottom;
	pVertex[2].color	= D3DCOLOR_ARGB (255, r, g, b);
	/* E */
	pVertex[3].x		= right;
	pVertex[3].y		= 0;
	pVertex[3].z		= top;
	pVertex[3].color	= D3DCOLOR_ARGB (255, r, g, b);

	m_pVB->Unlock ();
}


/* ========================================================================= */
/* ֐	:CPrimitiveRectangle::Draw										 */
/* e		:`															 */
/* t		:2008/09/21														 */
/* ========================================================================= */

void CPrimitiveRectangle::Draw(LPDIRECT3DDEVICE9 pDevice)
{
	pDevice->SetFVF (D3DFVF_CUSTOMVERTEX);
	pDevice->SetStreamSource (0, m_pVB, 0, sizeof (CUSTOMVERTEX));

	pDevice->DrawPrimitive (
			D3DPT_TRIANGLESTRIP,	/*  */
			0,						/* Jn_obt@CfbNX */
			2);						/* `悷v~eBu */
}

/* Copyright(C)URARA-works 2008 */
